# Database Population

An enhancement to the RBAC Migration job allows for the ability to add subroles to existing custom roles 
where a specifc subrole already exists. 

    For example adding psc:subrole:LR_EXECUTE_PROCESS,psc:subrole:LR_REMOVE_AND_DUMP_MEMORY,psc:subrole:LR_VIEW 
    to any custom roles that currently have psc:subrole:8b979825-c052-44c7-b81e-726f15455a13 
    which is the use live response subrole`


## Running the Script

Required environment variables:

`SUBROLE_TO_FIND` - The subrole the script will look for when scanning through custom roles

`SUBROLES_TO_ADD` - The subrole(s) the script will add to any custom roles that contained the `SUBROLE_TO_FIND`


To run the script locally:

    SUBROLE_TO_FIND=psc:subrole:8b979825-c052-44c7-b81e-726f15455a13 SUBROLES_TO_ADD=psc:subrole:LR_EXECUTE_PROCESS,psc:subrole:LR_REMOVE_AND_DUMP_MEMORY,psc:subrole:LR_VIEW ./prod_bootstrap_and_migrate_rbac.sh localdev --migrate-only --service-connectors --custom-subroles-updates --migration-plan
    
To run the script against dev/test/prod just run the above command in relevant environment 
(currently via the jenkins job, in the future a gitlab job)

Link to dev01 jenkins job (Accessible via ssm start-session): http://localhost:8088/dev01/job/RBAC_Migration

Link to dev01 gitlab job: https://gitlab.bit9.local/ops/cloud-infra/-/jobs/2708471
    
    SUBROLE_TO_FIND=psc:subrole:8b979825-c052-44c7-b81e-726f15455a13 SUBROLES_TO_ADD=psc:subrole:LR_EXECUTE_PROCESS,psc:subrole:LR_REMOVE_AND_DUMP_MEMORY,psc:subrole:LR_VIEW ./prod_bootstrap_and_migrate_rbac.sh dev01 --migrate-only --service-connectors --custom-subroles-updates --migration-plan
    
The `custom_role_subrole_migration` script is run by using the following flag `--custom-subroles-updates` 
when running the `./prod_bootstrap_and_migrate_rbac.sh` script.


Note: Running the `./prod_bootstrap_and_migrate_rbac.sh` script with the `--migration-plan` flag 
will only output what would have changed. When running without the `--migration-plan` flag 
the script will make the call to add the subroles to the custom roles.